Index: ctrl/firmware/Main/CubeMX/charger.ioc
===================================================================
--- ctrl/firmware/Main/CubeMX/charger.ioc	(revision 83)
+++ ctrl/firmware/Main/CubeMX/charger.ioc	(revision 84)
@@ -215,8 +215,9 @@
 Mcu.IP13=SYS
 Mcu.IP14=TIM3
-Mcu.IP15=TIM8
-Mcu.IP16=USART2
-Mcu.IP17=USART3
-Mcu.IP18=USART10
+Mcu.IP15=TIM6
+Mcu.IP16=TIM8
+Mcu.IP17=USART2
+Mcu.IP18=USART3
+Mcu.IP19=USART10
 Mcu.IP2=DMA
 Mcu.IP3=FATFS
@@ -227,5 +228,5 @@
 Mcu.IP8=RCC
 Mcu.IP9=RTC
-Mcu.IPNb=19
+Mcu.IPNb=20
 Mcu.Name=STM32H723ZETx
 Mcu.Package=LQFP144
@@ -256,39 +257,42 @@
 Mcu.Pin30=PA13(JTMS/SWDIO)
 Mcu.Pin31=PA14(JTCK/SWCLK)
-Mcu.Pin32=PC10
-Mcu.Pin33=PC11
-Mcu.Pin34=PC12
-Mcu.Pin35=PD2
-Mcu.Pin36=PD3
-Mcu.Pin37=PD4
-Mcu.Pin38=PD5
-Mcu.Pin39=PD6
+Mcu.Pin32=PA15(JTDI)
+Mcu.Pin33=PC10
+Mcu.Pin34=PC11
+Mcu.Pin35=PC12
+Mcu.Pin36=PD2
+Mcu.Pin37=PD3
+Mcu.Pin38=PD4
+Mcu.Pin39=PD5
 Mcu.Pin4=PC15-OSC32_OUT
-Mcu.Pin40=PD7
-Mcu.Pin41=PG9
-Mcu.Pin42=PG10
-Mcu.Pin43=PG11
-Mcu.Pin44=PG12
-Mcu.Pin45=PG13
-Mcu.Pin46=PG14
-Mcu.Pin47=PG15
-Mcu.Pin48=PB4(NJTRST)
-Mcu.Pin49=PB8
+Mcu.Pin40=PD6
+Mcu.Pin41=PD7
+Mcu.Pin42=PG9
+Mcu.Pin43=PG10
+Mcu.Pin44=PG11
+Mcu.Pin45=PG12
+Mcu.Pin46=PG13
+Mcu.Pin47=PG14
+Mcu.Pin48=PG15
+Mcu.Pin49=PB4(NJTRST)
 Mcu.Pin5=PH0-OSC_IN
-Mcu.Pin50=PB9
-Mcu.Pin51=VP_FATFS_VS_SDIO
-Mcu.Pin52=VP_FREERTOS_VS_CMSIS_V2
-Mcu.Pin53=VP_RTC_VS_RTC_Activate
-Mcu.Pin54=VP_RTC_VS_RTC_Calendar
-Mcu.Pin55=VP_SYS_VS_tim7
-Mcu.Pin56=VP_TIM3_VS_ClockSourceINT
-Mcu.Pin57=VP_TIM8_VS_ControllerModeReset
-Mcu.Pin58=VP_TIM8_VS_ClockSourceINT
-Mcu.Pin59=VP_MEMORYMAP_VS_MEMORYMAP
+Mcu.Pin50=PB8
+Mcu.Pin51=PB9
+Mcu.Pin52=VP_FATFS_VS_SDIO
+Mcu.Pin53=VP_FREERTOS_VS_CMSIS_V2
+Mcu.Pin54=VP_RTC_VS_RTC_Activate
+Mcu.Pin55=VP_RTC_VS_RTC_Calendar
+Mcu.Pin56=VP_SYS_VS_tim7
+Mcu.Pin57=VP_TIM3_VS_ClockSourceINT
+Mcu.Pin58=VP_TIM6_VS_ClockSourceINT
+Mcu.Pin59=VP_TIM6_VS_OPM
 Mcu.Pin6=PH1-OSC_OUT
+Mcu.Pin60=VP_TIM8_VS_ControllerModeReset
+Mcu.Pin61=VP_TIM8_VS_ClockSourceINT
+Mcu.Pin62=VP_MEMORYMAP_VS_MEMORYMAP
 Mcu.Pin7=PF15
 Mcu.Pin8=PG0
 Mcu.Pin9=PG1
-Mcu.PinsNb=60
+Mcu.PinsNb=63
 Mcu.ThirdParty0=STMicroelectronics.X-CUBE-AZRTOS-H7.3.3.0
 Mcu.ThirdPartyNb=1
@@ -360,4 +364,9 @@
 PA14(JTCK/SWCLK).Mode=Serial_Wire
 PA14(JTCK/SWCLK).Signal=DEBUG_JTCK-SWCLK
+PA15(JTDI).GPIOParameters=GPIO_PuPd,GPIO_Label
+PA15(JTDI).GPIO_Label=ONEWIRE_TEMP_BUS
+PA15(JTDI).GPIO_PuPd=GPIO_NOPULL
+PA15(JTDI).Locked=true
+PA15(JTDI).Signal=GPIO_Output
 PA8.GPIOParameters=GPIO_PuPd,GPIO_Label
 PA8.GPIO_Label=SD_DETECT
@@ -579,5 +588,5 @@
 ProjectManager.UAScriptBeforePath=
 ProjectManager.UnderRoot=true
-ProjectManager.functionlistsort=1-MX_GPIO_Init-GPIO-false-HAL-true,2-MX_DMA_Init-DMA-false-HAL-true,3-MX_MDMA_Init-MDMA-false-HAL-true,4-MX_RTC_Init-RTC-false-HAL-true,5-MX_SPI4_Init-SPI4-false-HAL-true,6-MX_SDMMC1_SD_Init-SDMMC1-false-HAL-true,7-MX_USART3_UART_Init-USART3-false-HAL-true,8-MX_TIM3_Init-TIM3-false-HAL-true,9-SystemClock_Config-RCC-false-HAL-false,10-MX_FATFS_Init-FATFS-false-HAL-false,11-MX_TIM8_Init-TIM8-false-HAL-true,12-MX_SPI2_Init-SPI2-false-HAL-true,13-MX_USART2_UART_Init-USART2-false-HAL-true,14-MX_USART10_UART_Init-USART10-false-HAL-true,0-MX_CORTEX_M7_Init-CORTEX_M7-false-HAL-true
+ProjectManager.functionlistsort=1-MX_GPIO_Init-GPIO-false-HAL-true,2-MX_DMA_Init-DMA-false-HAL-true,3-MX_MDMA_Init-MDMA-false-HAL-true,4-MX_RTC_Init-RTC-false-HAL-true,5-MX_SPI4_Init-SPI4-false-HAL-true,6-MX_SDMMC1_SD_Init-SDMMC1-false-HAL-true,7-MX_USART3_UART_Init-USART3-false-HAL-true,8-MX_TIM3_Init-TIM3-false-HAL-true,9-SystemClock_Config-RCC-false-HAL-false,10-MX_FATFS_Init-FATFS-false-HAL-false,11-MX_TIM8_Init-TIM8-false-HAL-true,12-MX_SPI2_Init-SPI2-false-HAL-true,13-MX_USART2_UART_Init-USART2-false-HAL-true,14-MX_USART10_UART_Init-USART10-false-HAL-true,15-MX_TIM6_Init-TIM6-false-HAL-true,0-MX_CORTEX_M7_Init-CORTEX_M7-false-HAL-true
 RCC.ADCFreq_Value=125000000
 RCC.AHB12Freq_Value=100000000
@@ -663,5 +672,5 @@
 RCC.VCOInput2Freq_Value=12500000
 RCC.VCOInput3Freq_Value=1000000
-SDMMC1.ClockDiv=1
+SDMMC1.ClockDiv=2
 SDMMC1.ClockPowerSave=SDMMC_CLOCK_POWER_SAVE_ENABLE
 SDMMC1.HardwareFlowControl=SDMMC_HARDWARE_FLOW_CONTROL_ENABLE
@@ -721,4 +730,7 @@
 TIM3.Prescaler=3
 TIM3.Pulse-PWM\ Generation2\ CH2=200
+TIM6.AutoReloadPreload=TIM_AUTORELOAD_PRELOAD_ENABLE
+TIM6.IPParameters=AutoReloadPreload,Prescaler
+TIM6.Prescaler=99
 TIM8.AutoReloadPreload=TIM_AUTORELOAD_PRELOAD_ENABLE
 TIM8.Channel-Input_Capture1_from_TI1=TIM_CHANNEL_1
@@ -751,4 +763,8 @@
 VP_TIM3_VS_ClockSourceINT.Mode=Internal
 VP_TIM3_VS_ClockSourceINT.Signal=TIM3_VS_ClockSourceINT
+VP_TIM6_VS_ClockSourceINT.Mode=Enable_Timer
+VP_TIM6_VS_ClockSourceINT.Signal=TIM6_VS_ClockSourceINT
+VP_TIM6_VS_OPM.Mode=OPM_bit
+VP_TIM6_VS_OPM.Signal=TIM6_VS_OPM
 VP_TIM8_VS_ClockSourceINT.Mode=Internal
 VP_TIM8_VS_ClockSourceINT.Signal=TIM8_VS_ClockSourceINT